#ifndef POINT_SET_CONFIG_H
#define POINT_SET_CONFIG_H

#include "Base_config.h"

namespace p2c
{

struct Point_set_config : public Base_config
{

    std::string dir_project;
    std::string fn_pointset;
    std::string fn_bounding_mesh;
    std::string fn_landmarks_pointset;

    double dbl_keep_vertices_weight;

    int int_detail_level;

    Point_set_config() :
        fn_bounding_mesh(""),
        dbl_keep_vertices_weight(0.0),
        int_detail_level(2)
    {}

    void init(const std::vector<std::string>& argv, std::map<std::string, std::string>& data)
    {
        for (size_t i=0; i < argv.size(); ++i)
        {
            if (argv[i] == "-p" && argv.size() > i+1)
            {
                dir_project = argv[i+1];
                if (dir_project.back() != '/')
                    dir_project.push_back('/');
            }
        }

        find_key(data, "fn_pointset", fn_pointset, dir_project);
        find_key(data, "fn_bounding_mesh", fn_bounding_mesh, dir_project);
        find_key(data, "fn_landmarks_pointset", fn_landmarks_pointset, dir_project);
        find_key(data, "dbl_keep_vertices_weight", dbl_keep_vertices_weight);

        find_key(data, "int_detail_level", int_detail_level);

    }

};

}


#endif
