#ifndef Pointset_config_H
#define Pointset_config_H

#include "Base_config.h"

namespace p2c
{

struct Pointset_config : public Base_config
{
    std::string dir_project;
    std::string fn_pointset;
    std::string fn_landmarks;

    bool b_landmarks_only_before_finefit;
    int int_detail_level;

    Pointset_config() :
        b_landmarks_only_before_finefit(false),
        int_detail_level(2)
    {}

    void init(const std::vector<std::string>& argv, std::map<std::string, std::string>& data)
    {
        for (size_t i=0; i < argv.size(); ++i)
        {
            if (argv[i] == "-p" && argv.size() > i+1)
            {
                dir_project = argv[i+1];
                if (dir_project.back() != '/')
                    dir_project.push_back('/');
            }
        }

        find_key(data, "fn_pointset", fn_pointset, dir_project);
        find_key(data, "fn_landmarks", fn_landmarks, dir_project);
        find_key(data, "int_detail_level", int_detail_level);
        find_key(data, "b_landmarks_only_before_finefit", b_landmarks_only_before_finefit);
    }

};

}


#endif
