//=============================================================================

#pragma once

//=============================================================================

#include <graphene/character/data_structure/Character.h>

//=============================================================================

namespace graphene {
namespace character {
//=============================================================================

struct Smoothing_options
{
    explicit Smoothing_options()
    {
        use_uniform_laplace = true;
        use_implicit_smoothing = false;
        iterations = 5;
        timestep = 0.00001;
    }

    bool   use_uniform_laplace;
    bool   use_implicit_smoothing;
    int    iterations;
    double timestep;
};

bool smooth_selection(Character& character, const std::string& s_bodymesh, const std::string& fn_selection,
                      Smoothing_options options = Smoothing_options());

//=============================================================================
} // namespace character
} // namespace graphene
//=============================================================================
