//-----------------------------------------------------------------------------

#pragma once

#include <vector>

#include <graphene/gl/gl_includes.h>

//-----------------------------------------------------------------------------

namespace graphene
{
    namespace utility { struct Landmark_guidance; }
}

//-----------------------------------------------------------------------------

namespace graphene
{
namespace gl
{

//-----------------------------------------------------------------------------

struct Landmark_image
{
    GLuint texture_handle;
    int width;
    int height;

    // Cast OpenGL texture handle to void* for ImGui Rendering
    void* handle() { return (void*)(intptr_t)texture_handle; }
};

//-----------------------------------------------------------------------------

class Landmark_guidance_gl
{
public:

    Landmark_guidance_gl();

    ~Landmark_guidance_gl();

    bool valid();

    bool load(graphene::utility::Landmark_guidance& landmark_guidance);

    Landmark_image& get(size_t landmark);

private:

    void clear();

    std::vector<Landmark_image> landmark_images_;
};

//-----------------------------------------------------------------------------

}
}

//-----------------------------------------------------------------------------
