//=============================================================================

#ifndef SMOOTHER_H
#define SMOOTHER_H


//== INCLUDES =================================================================

#include <graphene/surface_mesh/data_structure/Surface_mesh.h>


//== NAMESPACES ===============================================================

namespace graphene {
namespace surface_mesh {


//== CLASS DEFINITION =========================================================


class Smoother
{
public:

    // constructor
    Smoother(Surface_mesh& mesh);

    // destructor
    ~Smoother();

    // compute cotangent weights
    void initialize(bool use_uniform_laplace);

    // smooth _n iterations (explicit smoothing)
    void smooth(unsigned int _n, bool use_uniform_laplace = false);

    // smooth _n iterations (implicit smoothing)
    void smooth_implicit(double timestep, bool use_uniform_laplace = false);

private:

    Surface_mesh&  mesh_;
    bool initialized_;
    Surface_mesh::Vertex_property<double> vweight_;
    Surface_mesh::Edge_property<double>   eweight_;
};


//-----------------------------------------------------------------------------


void smooth(Surface_mesh& mesh, unsigned int iterations);

//=============================================================================
} // namespace surface_mesh
} // namespace graphene
//=============================================================================
#endif
//=============================================================================

