//-----------------------------------------------------------------------------

#pragma once

#include <graphene/geometry/Matrix4x4.h>
#include <graphene/surface_mesh/data_structure/Surface_mesh.h>

//-----------------------------------------------------------------------------

namespace graphene {
namespace surface_mesh {

//-----------------------------------------------------------------------------

class Mesh_stitcher
{
public:
    Mesh_stitcher(Surface_mesh& mesh, std::vector<int>& vertex_mapping);
    ~Mesh_stitcher();

    Mat4f stitch();

private:
    void save_undeformed_state(std::vector<int>& vertex_mapping);

    void compute_laplace(const std::string& property_name);

    Surface_mesh& mesh_;
    int num_free_vertices_;
};

//-----------------------------------------------------------------------------

} // namespace surface_mesh
} // namespace graphene

//-----------------------------------------------------------------------------
