//=============================================================================


#ifndef GRAPHENE_ENERGY_TERM_PCA_CPC_PS2MESH_SKINNED_TWOSCANS_H
#define GRAPHENE_ENERGY_TERM_PCA_CPC_PS2MESH_SKINNED_TWOSCANS_H


//== INCLUDES =================================================================


#include "Energy_term.h"

#include "../my_types.h"


//== NAMESPACE ================================================================


namespace graphene {
namespace surface_mesh {


//== CLASS DEFINITION =========================================================

//NOTE(swenninger): Deprecated

#if 0

class
Energy_term_pca_cpc_ps2mesh_skinned_twoscans : public Energy_term
{
public:

    Energy_term_pca_cpc_ps2mesh_skinned_twoscans(const Energy_term_data& energy_term_data, double weight);

    virtual ~Energy_term_pca_cpc_ps2mesh_skinned_twoscans();

    virtual void pre_minimize_action();

    virtual double evaluate();

    virtual void add_rows_big_lse( std::vector<Tripl>& coeffs,
                                   Eigen::VectorXd& b,
                                   unsigned int& r );

    virtual unsigned int n_rows_big_sle();

    virtual bool small_sle_supported() { return false; }

    virtual bool needs_correspondences() { return true; }

    virtual bool requires_two_pointsets_and_posevectors() {return true;}

    virtual bool needs_pca() {return true;}

    virtual void solve_result(std::set<Solve_result>& solve_results) {solve_results.insert(SR_PCA);}


private:

    // front_body
    std::vector<Eigen::MatrixXd> Tj_times_Hi_front_body_;
    std::vector<Eigen::VectorXd> Tj_times_pcamean_front_body_;

    // back_body
    std::vector<Eigen::MatrixXd> Tj_times_Hi_back_body_;
    std::vector<Eigen::VectorXd> Tj_times_pcamean_back_body_;

};

#endif

//=============================================================================
} // namespace surface_mesh
} // namespace graphene
//=============================================================================
#endif // GRAPHENE_ENERGY_TERM_PCA_CPC_PS2MESH_SKINNED_TWOSCANS_H
//=============================================================================
